## CinnamonAppSystem CinnamonAppSystem |

## Functions

CinnamonAppSystem * | cinnamon_app_system_get_default ()
GMenuTree * | cinnamon_app_system_get_tree ()
CinnamonApp * | cinnamon_app_system_lookup_app ()
CinnamonApp * | cinnamon_app_system_lookup_startup_wmclass ()
CinnamonApp * | cinnamon_app_system_lookup_desktop_wmclass ()
CinnamonApp * | cinnamon_app_system_lookup_flatpak_app_id ()
GSList * | cinnamon_app_system_get_all ()
GSList * | cinnamon_app_system_get_running ()

## Signals

void | app-state-changed | Run Last
void | installed-changed | Run Last

## Object Hierarchy

        GObject
        ╰── CinnamonAppSystem

## Description

## Functions

### cinnamon_app_system_get_default ()

    CinnamonAppSystem *
    cinnamon_app_system_get_default (void);

#### Returns

The global CinnamonAppSystem singleton.

[transfer none]

### cinnamon_app_system_get_tree ()

    GMenuTree *
    cinnamon_app_system_get_tree (CinnamonAppSystem *system);

#### Returns

The GMenuTree for apps.

[transfer none]

### cinnamon_app_system_lookup_app ()

    CinnamonApp *
    cinnamon_app_system_lookup_app (CinnamonAppSystem *system,
                                    const char *id);

Find a CinnamonApp corresponding to an id.

#### Returns

The CinnamonApp for id, or `NULL` if none.

[transfer none]

### cinnamon_app_system_lookup_startup_wmclass ()

    CinnamonApp *
    cinnamon_app_system_lookup_startup_wmclass
                                   (CinnamonAppSystem *system,
                                    const char *wmclass);

Find a valid application whose .desktop file contains a StartupWMClass entry matching `wmclass` .

#### Parameters

system | a CinnamonAppSystem |
wmclass | A WM_CLASS value. | [nullable]

#### Returns

A CinnamonApp for `wmclass` .

[transfer none]

### cinnamon_app_system_lookup_desktop_wmclass ()

    CinnamonApp *
    cinnamon_app_system_lookup_desktop_wmclass
                                   (CinnamonAppSystem *system,
                                    const char *wmclass);

Find a valid application whose .desktop file, without the extension and properly canonicalized, matches `wmclass` .

#### Parameters

system | a CinnamonAppSystem |
wmclass | A WM_CLASS value. | [nullable]

#### Returns

A CinnamonApp for `wmclass` .

[transfer none]

### cinnamon_app_system_lookup_flatpak_app_id ()

    CinnamonApp *
    cinnamon_app_system_lookup_flatpak_app_id
                                   (CinnamonAppSystem *system,
                                    const char *app_id);

Find a CinnamonApp corresponding to a flatpak app id.

#### Returns

The CinnamonApp for app_id, or `NULL` if none.

[transfer none]

### cinnamon_app_system_get_all ()

    GSList *
    cinnamon_app_system_get_all (CinnamonAppSystem *system);

#### Returns

All installed applications.

[transfer container][element-type CinnamonApp]

### cinnamon_app_system_get_running ()

    GSList *
    cinnamon_app_system_get_running (CinnamonAppSystem *self);

Returns the set of applications which currently have at least one open window in the given context.

#### Parameters

self | A CinnamonAppSystem |

#### Returns

Active applications.

[element-type CinnamonApp][transfer container]

## Signal Details

### The `“app-state-changed”` signal

    void
    user_function (CinnamonAppSystem *cinnamonappsystem,
                   CinnamonApp       *arg1,
                   gpointer           user_data)

Flags: Run Last

### The `“installed-changed”` signal

    void
    user_function (CinnamonAppSystem *cinnamonappsystem,
                   gpointer           user_data)

Flags: Run Last